package Foswiki::Plugins::PingPlugin;
use strict;


our $VERSION = '0.1';
our $RELEASE = '0.1';
our $SHORTDESCRIPTION = 'Ping plugin';
our $NO_PREFS_IN_TOPIC = 0;
our $pluginName = 'PingPlugin';

sub initPlugin {
    my( $topic, $web, $user, $installWeb ) = @_;
    
    Foswiki::Func::registerTagHandler( 'PING', \&_PING );
    Foswiki::Func::registerTagHandler( 'ICMPPING', \&_ICMPPING );

    return 1;
}

sub _PING {
    my($session, $params, $theTopic, $theWeb) = @_;
    
    my $ip = $params->{_DEFAULT} || '';
    my $detail = $params->{detail} || '';
    my $timeout = $params->{timeout} || '';
    my $icon = $params->{icon} || '';
    
    if (int($timeout) > 0)
    {
      $timeout = $timeout/1000;
    } else {
      $timeout = 0.1;
    }   
    
    use Net::Ping;
    my $p = Net::Ping->new();
    my ($ret, $duration, $ip2) = $p->ping("$ip", $timeout);
   
    if ($detail eq "yes")
      {
        if ($ret == 1) 
        {
          return "Reply from " . $ip . ", time=" . int($duration*1000) . "ms";
        }
        else
        {
          return "No answer from " . $ip . ", timeout=" . int($timeout*1000) . "ms";
        }
      } 
      else
      {
        if ($icon eq "yes")
        {
          if ($ret == 1)
          { 
            return "%ICON{choice-yes}%";
          }  
          else
          {
            return "%ICON{choice-no}%";
          }
        }
        else
        {
          return $ret;
        }
      }
}

sub _ICMPPING {
    my($session, $params, $theTopic, $theWeb) = @_;
    
    my $ip = $params->{_DEFAULT} || '';
    my $timeout = $params->{timeout} || '';
    my $icon = $params->{icon} || '';
    
    if (int($timeout) > 0)
    {
      $timeout = $timeout/1000;
    } else {
      $timeout = 1;
    }   
        
    use Net::Ping::External qw(ping);
    my $ret = ping(hostname => "$ip", count => 1, timeout => $timeout);
    
    if ($icon eq "yes")
        {
          if ($ret == 1)
          { 
            return "%ICON{choice-yes}%";
          }  
          else
          {
            return "%ICON{choice-no}%";
          }
        }
    else
        {
          return $ret;
        }
}

